#include <stdio.h>
#include <stdlib.h>

struct node {
	int v;
	struct node *next;
};

struct graph {
	int V;
	int E;
	struct node **A;
};

struct graph *creategraph(int nv, int ne)
{
	struct graph *g = malloc(sizeof(struct graph));
	
	if(!g) {
		fprintf(stderr,"Errore di Allocazione\n");
		exit(-1);
	}
	g->E = ne;
	g->V = nv;
	if(!(g->A = calloc(nv,sizeof(struct node *))))  {
		fprintf(stderr,"Errore di Allocazione\n");
		exit(-2);
	}
	return g;
}

struct node *vertexinsert(struct node *p, int k)
{
	struct node *q = malloc(sizeof(struct node));

	if(!q) {
		fprintf(stderr,"Errore di Allocazione\n");
		exit(-3);
	}
	q->v = k;
	q->next = p;
	return q;
}

void readgraph(struct graph *g, FILE *fp)
{
	int i,v1, v2;
	
	for(i = 0; i < g->E; i++) {
		fscanf(fp,"%d %d",&v1,&v2);
		g->A[v1-1] = vertexinsert(g->A[v1-1],v2);
		g->A[v2-1] = vertexinsert(g->A[v2-1],v1);		
	}		
}

void dfs1(struct graph *g, int i, int *aux)
{
	struct node *t;

	aux[i] = 1;
	for(t = g->A[i]; t; t = t->next)
		if(!aux[t->v - 1]) {
			printf("%d,",t->v);
			dfs1(g,t->v-1,aux);
		}
}

void dfs(struct graph *g)
{
	int i;
	int *aux = calloc(g->V,sizeof(int));

	if(!aux) {
		fprintf(stderr,"Errore di Allocazione\n");
		exit(-4);
	}
	for(i = 0; i < g->V; i++)
		if(!aux[i]) {
			printf("\n%d,",i+1);
			dfs1(g,i,aux);
		}
	free(aux);
}

void stampalista(struct node *p)
{
	for(;p; p =p->next)
		printf("->%d",p->v);
}

int main(int ac, char **av)
{
	int nv, ne;
	struct graph *g;
	FILE *fp;

	if(ac != 2) {
		fprintf(stderr,"Uso: %s <file>\n",av[0]);
		exit(-1);
	};
	if(!(fp = fopen(av[1],"r"))) {
	fprintf(stderr,"File %s non trovato\n",av[1]);
		exit(-2);
	};	

	fscanf(fp,"%d %d", &nv, &ne);
	g = creategraph(nv,ne);
	readgraph(g,fp);

	/*
	for(i = 0; i < nv; i++) {
		printf("\n[%d]",i+1);
		stampalista(g->A[i]);
	}
	*/	

	printf("\n\nVisita in profondita':\n");
	dfs(g);

	return 0;
}
