/* compilare con gcc -o testtreepair testtreepair.c treepair.c readwordmodule.c */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "treepair.h"
#include "readword.h"

char separator(char c)
{
	return isspace(c) || ispunct(c);
}

/* legge n parole dal file fp ne calcola la lunghezz e inserisce le coppie */
/* (lunghezza, parola) in un treepair di cui restituisce la radice */
treepair *caricaparole(FILE *fp, int n)
{
	int i,c;
	char *s;
	treepair *root = createtreepair();

	for(i = 0; i < n; i++) {
		while(separator(c = fgetc(fp)));
		ungetc(c,fp);
		s = readword(fp,separator);
		insert(root,strlen(s),s);
	}
	return root;
}

void stampanodo(treepairnode *p)
{
	printf("[%d,%s] ", getintdatum(p), getstrdatum(p));
}

void stampaordine(treepair *root)
{
	printf("\n\n Ordine rispetto alle lunghezze:\n");
	inorder(getintroot(root),stampanodo);
	printf("\n\n Ordine rispetto alle parole:\n");
	inorder(getstrroot(root),stampanodo);
}

int main(int ac, char **av)
{	
	FILE *fp;
	int n, k;
	char *s;
	treepair *root;
	treepairnode *q;

	if(ac != 3 || !(n = atoi(av[1])) ) {
		fprintf(stderr,"Uso: %s <n (n>0) > <file>\n",av[0]);
		exit(-1);
	};
	if(!(fp = fopen(av[2],"r"))) {
	fprintf(stderr,"File %s non trovato\n",av[2]);
		exit(-2);
	};

	root = caricaparole(fp,n);

	stampaordine(root);
	
	printf("\n\nImmetti parola da cancellare:");
	/* usa readword, definita in readword.c, con prototipo in readword.h */
	/* per leggere parole di lunghezza non limitabile a priori */
	s = readword(stdin,separator);
	
	/* cerca nel treepair di radice root un coppia che contenga la parola s */
	if((q = strsearch(root,s))) {
		printf("\n\nLa parola \"%s\" e' presente nell'albero\n",s);
		/* se la trova attraverso il nodo q, cancella la coppia dal treepair */
		delete(root,q);
	} else
		printf("\n\nLa parola \"%s\" non e' presente nell'albero\n",s);
		
	stampaordine(root);

	printf("\n\nImmetti la lunghezza delle parole da cancellare:");
	scanf("%d",&k);
	
	/* cancella tutte le coppie contenenti parole di lunghezza k dal treepair */
	while((q = intsearch(root,k)))
		delete(root,q);

	stampaordine(root);

	return 0;
}
	
